#include "helloworld.h"
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

HelloWorld::HelloWorld(WiiMoteThread* wii, QWidget *parent)
    : QMainWindow(parent)
{
	ui.setupUi(this);
	ui.lightsLR->setColor(QColor("blue"));
	ui.lightsKitchen->setColor(QColor("green"));

	livingRoomLED_state = 1;
	kitchenLED_state = 1;

	connect(ui.lightsLR, SIGNAL(powerClicked()), this, SLOT(livingRoomLights()));
	connect(ui.lightsKitchen, SIGNAL(powerClicked()), this, SLOT(kitchenLights()));
	connect(wii, SIGNAL(flipGarageDoorSwitch(int)), this, SLOT(garageSwitch(int)));

	this->showFullScreen();

	qApp->setStyleSheet("QWidget#centralwidget {border-image: url(:/Light-Blue.jpg)}");

}

HelloWorld::~HelloWorld()
{

}

void HelloWorld::livingRoomLights()
{
	int devfd;
	char buffer [10];

		if((devfd = open("/leds/living_room",O_WRONLY)) < 0)
		{
				if(errno == EBUSY)
						fprintf(stderr, "Device already in use\n");
		}else{
				/* change a state */
				if(livingRoomLED_state == 1)
					livingRoomLED_state=0;
				else
					livingRoomLED_state=1;


				sprintf(buffer,"%d", livingRoomLED_state);

				printf("living room lights - state changed %d\n", livingRoomLED_state);
				write(devfd,buffer,10);
		}

}

void HelloWorld::kitchenLights()
{
	int devfd;
	char buffer [10];

		if((devfd = open("/leds/kitchen",O_WRONLY)) < 0)
		{
				if(errno == EBUSY)
						fprintf(stderr, "Device already in use\n");
		}else{
				/* change a state */
				if(kitchenLED_state == 1)
					kitchenLED_state=0;
				else
					kitchenLED_state=1;


				sprintf(buffer,"%d", kitchenLED_state);

				printf("kitchen lights - state changed %d\n", kitchenLED_state);
				write(devfd,buffer,10);
		}

}

void HelloWorld::garageSwitch(int state)
{
	ui.garageDoor->setState(state);
}
